#include <iostream>


#include "rmsd.h"
#include "atom.h"
#include "atomselection.h"
#include "rigidbody.h"

namespace PTools{

double Rmsd(const AtomSelection& atsel1, const AtomSelection& atsel2)
{
if (atsel1.Size() != atsel2.Size())
{
std::cerr << "Error: trying to superpose two rigidbody of different sizes" << std::endl ;
throw "RmsdSizesDiffers";
}

double sum = 0.0;


for (uint i=0; i<atsel1.Size(); ++i)
{
  Atom atom1=atsel1.CopyAtom(i);
  Atom atom2=atsel2.CopyAtom(i);
  
  sum+=Dist2(atom1,atom2);
}

  return sqrt(sum)/(double) atsel1.Size() ;


}


} //namespace PTools

